# This file was autogenerated by some hot garbage in the `uniffi` crate.
# Trust me, you don't want to mess with it!

# Common helper code.
#
# Ideally this would live in a separate .py file where it can be unittested etc
# in isolation, and perhaps even published as a re-useable package.
#
# However, it's important that the details of how this helper code works (e.g. the
# way that different builtin types are passed across the FFI) exactly match what's
# expected by the rust code on the other side of the interface. In practice right
# now that means coming from the exact some version of `uniffi` that was used to
# compile the rust component. The easiest way to ensure this is to bundle the Python
# helpers directly inline like we're doing here.

import os
import sys
import ctypes
import enum
import struct
import contextlib
import datetime
import typing
import platform

# Used for default argument values
_DEFAULT = object()


class _UniffiRustBuffer(ctypes.Structure):
    _fields_ = [
        ("capacity", ctypes.c_int32),
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    @staticmethod
    def alloc(size):
        return _rust_call(_UniffiLib.ffi_c2pa_python_rustbuffer_alloc, size)

    @staticmethod
    def reserve(rbuf, additional):
        return _rust_call(_UniffiLib.ffi_c2pa_python_rustbuffer_reserve, rbuf, additional)

    def free(self):
        return _rust_call(_UniffiLib.ffi_c2pa_python_rustbuffer_free, self)

    def __str__(self):
        return "_UniffiRustBuffer(capacity={}, len={}, data={})".format(
            self.capacity,
            self.len,
            self.data[0:self.len]
        )

    @contextlib.contextmanager
    def alloc_with_builder(*args):
        """Context-manger to allocate a buffer using a _UniffiRustBufferBuilder.

        The allocated buffer will be automatically freed if an error occurs, ensuring that
        we don't accidentally leak it.
        """
        builder = _UniffiRustBufferBuilder()
        try:
            yield builder
        except:
            builder.discard()
            raise

    @contextlib.contextmanager
    def consume_with_stream(self):
        """Context-manager to consume a buffer using a _UniffiRustBufferStream.

        The _UniffiRustBuffer will be freed once the context-manager exits, ensuring that we don't
        leak it even if an error occurs.
        """
        try:
            s = _UniffiRustBufferStream.from_rust_buffer(self)
            yield s
            if s.remaining() != 0:
                raise RuntimeError("junk data left in buffer at end of consume_with_stream")
        finally:
            self.free()

    @contextlib.contextmanager
    def read_with_stream(self):
        """Context-manager to read a buffer using a _UniffiRustBufferStream.

        This is like consume_with_stream, but doesn't free the buffer afterwards.
        It should only be used with borrowed `_UniffiRustBuffer` data.
        """
        s = _UniffiRustBufferStream.from_rust_buffer(self)
        yield s
        if s.remaining() != 0:
            raise RuntimeError("junk data left in buffer at end of read_with_stream")

class _UniffiForeignBytes(ctypes.Structure):
    _fields_ = [
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    def __str__(self):
        return "_UniffiForeignBytes(len={}, data={})".format(self.len, self.data[0:self.len])


class _UniffiRustBufferStream:
    """
    Helper for structured reading of bytes from a _UniffiRustBuffer
    """

    def __init__(self, data, len):
        self.data = data
        self.len = len
        self.offset = 0

    @classmethod
    def from_rust_buffer(cls, buf):
        return cls(buf.data, buf.len)

    def remaining(self):
        return self.len - self.offset

    def _unpack_from(self, size, format):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        value = struct.unpack(format, self.data[self.offset:self.offset+size])[0]
        self.offset += size
        return value

    def read(self, size):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        data = self.data[self.offset:self.offset+size]
        self.offset += size
        return data

    def read_i8(self):
        return self._unpack_from(1, ">b")

    def read_u8(self):
        return self._unpack_from(1, ">B")

    def read_i16(self):
        return self._unpack_from(2, ">h")

    def read_u16(self):
        return self._unpack_from(2, ">H")

    def read_i32(self):
        return self._unpack_from(4, ">i")

    def read_u32(self):
        return self._unpack_from(4, ">I")

    def read_i64(self):
        return self._unpack_from(8, ">q")

    def read_u64(self):
        return self._unpack_from(8, ">Q")

    def read_float(self):
        v = self._unpack_from(4, ">f")
        return v

    def read_double(self):
        return self._unpack_from(8, ">d")

    def read_c_size_t(self):
        return self._unpack_from(ctypes.sizeof(ctypes.c_size_t) , "@N")

class _UniffiRustBufferBuilder:
    """
    Helper for structured writing of bytes into a _UniffiRustBuffer.
    """

    def __init__(self):
        self.rbuf = _UniffiRustBuffer.alloc(16)
        self.rbuf.len = 0

    def finalize(self):
        rbuf = self.rbuf
        self.rbuf = None
        return rbuf

    def discard(self):
        if self.rbuf is not None:
            rbuf = self.finalize()
            rbuf.free()

    @contextlib.contextmanager
    def _reserve(self, num_bytes):
        if self.rbuf.len + num_bytes > self.rbuf.capacity:
            self.rbuf = _UniffiRustBuffer.reserve(self.rbuf, num_bytes)
        yield None
        self.rbuf.len += num_bytes

    def _pack_into(self, size, format, value):
        with self._reserve(size):
            # XXX TODO: I feel like I should be able to use `struct.pack_into` here but can't figure it out.
            for i, byte in enumerate(struct.pack(format, value)):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write(self, value):
        with self._reserve(len(value)):
            for i, byte in enumerate(value):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write_i8(self, v):
        self._pack_into(1, ">b", v)

    def write_u8(self, v):
        self._pack_into(1, ">B", v)

    def write_i16(self, v):
        self._pack_into(2, ">h", v)

    def write_u16(self, v):
        self._pack_into(2, ">H", v)

    def write_i32(self, v):
        self._pack_into(4, ">i", v)

    def write_u32(self, v):
        self._pack_into(4, ">I", v)

    def write_i64(self, v):
        self._pack_into(8, ">q", v)

    def write_u64(self, v):
        self._pack_into(8, ">Q", v)

    def write_float(self, v):
        self._pack_into(4, ">f", v)

    def write_double(self, v):
        self._pack_into(8, ">d", v)

    def write_c_size_t(self, v):
        self._pack_into(ctypes.sizeof(ctypes.c_size_t) , "@N", v)
# A handful of classes and functions to support the generated data structures.
# This would be a good candidate for isolating in its own ffi-support lib.

class InternalError(Exception):
    pass

class _UniffiRustCallStatus(ctypes.Structure):
    """
    Error runtime.
    """
    _fields_ = [
        ("code", ctypes.c_int8),
        ("error_buf", _UniffiRustBuffer),
    ]

    # These match the values from the uniffi::rustcalls module
    CALL_SUCCESS = 0
    CALL_ERROR = 1
    CALL_PANIC = 2

    def __str__(self):
        if self.code == _UniffiRustCallStatus.CALL_SUCCESS:
            return "_UniffiRustCallStatus(CALL_SUCCESS)"
        elif self.code == _UniffiRustCallStatus.CALL_ERROR:
            return "_UniffiRustCallStatus(CALL_ERROR)"
        elif self.code == _UniffiRustCallStatus.CALL_PANIC:
            return "_UniffiRustCallStatus(CALL_PANIC)"
        else:
            return "_UniffiRustCallStatus(<invalid code>)"

def _rust_call(fn, *args):
    # Call a rust function
    return _rust_call_with_error(None, fn, *args)

def _rust_call_with_error(error_ffi_converter, fn, *args):
    # Call a rust function and handle any errors
    #
    # This function is used for rust calls that return Result<> and therefore can set the CALL_ERROR status code.
    # error_ffi_converter must be set to the _UniffiConverter for the error class that corresponds to the result.
    call_status = _UniffiRustCallStatus(code=_UniffiRustCallStatus.CALL_SUCCESS, error_buf=_UniffiRustBuffer(0, 0, None))

    args_with_error = args + (ctypes.byref(call_status),)
    result = fn(*args_with_error)
    _uniffi_check_call_status(error_ffi_converter, call_status)
    return result

def _uniffi_check_call_status(error_ffi_converter, call_status):
    if call_status.code == _UniffiRustCallStatus.CALL_SUCCESS:
        pass
    elif call_status.code == _UniffiRustCallStatus.CALL_ERROR:
        if error_ffi_converter is None:
            call_status.error_buf.free()
            raise InternalError("_rust_call_with_error: CALL_ERROR, but error_ffi_converter is None")
        else:
            raise error_ffi_converter.lift(call_status.error_buf)
    elif call_status.code == _UniffiRustCallStatus.CALL_PANIC:
        # When the rust code sees a panic, it tries to construct a _UniffiRustBuffer
        # with the message.  But if that code panics, then it just sends back
        # an empty buffer.
        if call_status.error_buf.len > 0:
            msg = _UniffiConverterString.lift(call_status.error_buf)
        else:
            msg = "Unknown rust panic"
        raise InternalError(msg)
    else:
        raise InternalError("Invalid _UniffiRustCallStatus code: {}".format(
            call_status.code))

# A function pointer for a callback as defined by UniFFI.
# Rust definition `fn(handle: u64, method: u32, args: _UniffiRustBuffer, buf_ptr: *mut _UniffiRustBuffer) -> int`
_UNIFFI_FOREIGN_CALLBACK_T = ctypes.CFUNCTYPE(ctypes.c_int, ctypes.c_ulonglong, ctypes.c_ulong, ctypes.POINTER(ctypes.c_char), ctypes.c_int, ctypes.POINTER(_UniffiRustBuffer))

# UniFFI future continuation
_UNIFFI_FUTURE_CONTINUATION_T = ctypes.CFUNCTYPE(None, ctypes.c_size_t, ctypes.c_int8)
class _UniffiPointerManagerCPython:
    """
    Manage giving out pointers to Python objects on CPython

    This class is used to generate opaque pointers that reference Python objects to pass to Rust.
    It assumes a CPython platform.  See _UniffiPointerManagerGeneral for the alternative.
    """

    def new_pointer(self, obj):
        """
        Get a pointer for an object as a ctypes.c_size_t instance

        Each call to new_pointer() must be balanced with exactly one call to release_pointer()

        This returns a ctypes.c_size_t.  This is always the same size as a pointer and can be
        interchanged with pointers for FFI function arguments and return values.
        """
        # IncRef the object since we're going to pass a pointer to Rust
        ctypes.pythonapi.Py_IncRef(ctypes.py_object(obj))
        # id() is the object address on CPython
        # (https://docs.python.org/3/library/functions.html#id)
        return id(obj)

    def release_pointer(self, address):
        py_obj = ctypes.cast(address, ctypes.py_object)
        obj = py_obj.value
        ctypes.pythonapi.Py_DecRef(py_obj)
        return obj

    def lookup(self, address):
        return ctypes.cast(address, ctypes.py_object).value

class _UniffiPointerManagerGeneral:
    """
    Manage giving out pointers to Python objects on non-CPython platforms

    This has the same API as _UniffiPointerManagerCPython, but doesn't assume we're running on
    CPython and is slightly slower.

    Instead of using real pointers, it maps integer values to objects and returns the keys as
    c_size_t values.
    """

    def __init__(self):
        self._map = {}
        self._lock = threading.Lock()
        self._current_handle = 0

    def new_pointer(self, obj):
        with self._lock:
            handle = self._current_handle
            self._current_handle += 1
            self._map[handle] = obj
        return handle

    def release_pointer(self, handle):
        with self._lock:
            return self._map.pop(handle)

    def lookup(self, handle):
        with self._lock:
            return self._map[handle]

# Pick an pointer manager implementation based on the platform
if platform.python_implementation() == 'CPython':
    _UniffiPointerManager = _UniffiPointerManagerCPython # type: ignore
else:
    _UniffiPointerManager = _UniffiPointerManagerGeneral # type: ignore
# Types conforming to `_UniffiConverterPrimitive` pass themselves directly over the FFI.
class _UniffiConverterPrimitive:
    @classmethod
    def check(cls, value):
        return value

    @classmethod
    def lift(cls, value):
        return value

    @classmethod
    def lower(cls, value):
        return cls.lowerUnchecked(cls.check(value))

    @classmethod
    def lowerUnchecked(cls, value):
        return value

    @classmethod
    def write(cls, value, buf):
        cls.write_unchecked(cls.check(value), buf)

class _UniffiConverterPrimitiveInt(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value):
        try:
            value = value.__index__()
        except Exception:
            raise TypeError("'{}' object cannot be interpreted as an integer".format(type(value).__name__))
        if not isinstance(value, int):
            raise TypeError("__index__ returned non-int (type {})".format(type(value).__name__))
        if not cls.VALUE_MIN <= value < cls.VALUE_MAX:
            raise ValueError("{} requires {} <= value < {}".format(cls.CLASS_NAME, cls.VALUE_MIN, cls.VALUE_MAX))
        return super().check(value)

class _UniffiConverterPrimitiveFloat(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value):
        try:
            value = value.__float__()
        except Exception:
            raise TypeError("must be real number, not {}".format(type(value).__name__))
        if not isinstance(value, float):
            raise TypeError("__float__ returned non-float (type {})".format(type(value).__name__))
        return super().check(value)

# Helper class for wrapper types that will always go through a _UniffiRustBuffer.
# Classes should inherit from this and implement the `read` and `write` static methods.
class _UniffiConverterRustBuffer:
    @classmethod
    def lift(cls, rbuf):
        with rbuf.consume_with_stream() as stream:
            return cls.read(stream)

    @classmethod
    def lower(cls, value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            cls.write(value, builder)
            return builder.finalize()

# Contains loading, initialization code, and the FFI Function declarations.
# Define some ctypes FFI types that we use in the library

"""
ctypes type for the foreign executor callback.  This is a built-in interface for scheduling
tasks

Args:
  executor: opaque c_size_t value representing the eventloop
  delay: delay in ms
  task: function pointer to the task callback
  task_data: void pointer to the task callback data

Normally we should call task(task_data) after the detail.
However, when task is NULL this indicates that Rust has dropped the ForeignExecutor and we should
decrease the EventLoop refcount.
"""
_UNIFFI_FOREIGN_EXECUTOR_CALLBACK_T = ctypes.CFUNCTYPE(ctypes.c_int8, ctypes.c_size_t, ctypes.c_uint32, ctypes.c_void_p, ctypes.c_void_p)

"""
Function pointer for a Rust task, which a callback function that takes a opaque pointer
"""
_UNIFFI_RUST_TASK = ctypes.CFUNCTYPE(None, ctypes.c_void_p, ctypes.c_int8)

def _uniffi_future_callback_t(return_type):
    """
    Factory function to create callback function types for async functions
    """
    return ctypes.CFUNCTYPE(None, ctypes.c_size_t, return_type, _UniffiRustCallStatus)

def _uniffi_load_indirect():
    """
    This is how we find and load the dynamic library provided by the component.
    For now we just look it up by name.
    """
    if sys.platform == "darwin":
        libname = "lib{}.dylib"
    elif sys.platform.startswith("win"):
        # As of python3.8, ctypes does not seem to search $PATH when loading DLLs.
        # We could use `os.add_dll_directory` to configure the search path, but
        # it doesn't feel right to mess with application-wide settings. Let's
        # assume that the `.dll` is next to the `.py` file and load by full path.
        libname = os.path.join(
            os.path.dirname(__file__),
            "{}.dll",
        )
    else:
        # Anything else must be an ELF platform - Linux, *BSD, Solaris/illumos
        libname = "lib{}.so"

    libname = libname.format("uniffi_c2pa")
    path = os.path.join(os.path.dirname(__file__), libname)
    lib = ctypes.cdll.LoadLibrary(path)
    return lib

def _uniffi_check_contract_api_version(lib):
    # Get the bindings contract version from our ComponentInterface
    bindings_contract_version = 24
    # Get the scaffolding contract version by calling the into the dylib
    scaffolding_contract_version = lib.ffi_c2pa_python_uniffi_contract_version()
    if bindings_contract_version != scaffolding_contract_version:
        raise InternalError("UniFFI contract version mismatch: try cleaning and rebuilding your project")

def _uniffi_check_api_checksums(lib):
    if lib.uniffi_c2pa_python_checksum_func_read_file() != 35657:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_c2pa_python_checksum_func_read_ingredient_file() != 7940:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_c2pa_python_checksum_func_sdk_version() != 5815:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_c2pa_python_checksum_func_sign_file() != 29403:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_c2pa_python_checksum_func_version() != 27802:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")

# A ctypes library to expose the extern-C FFI definitions.
# This is an implementation detail which will be called internally by the public API.

_UniffiLib = _uniffi_load_indirect()
_UniffiLib.uniffi_c2pa_python_fn_func_read_file.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_c2pa_python_fn_func_read_file.restype = _UniffiRustBuffer
_UniffiLib.uniffi_c2pa_python_fn_func_read_ingredient_file.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_c2pa_python_fn_func_read_ingredient_file.restype = _UniffiRustBuffer
_UniffiLib.uniffi_c2pa_python_fn_func_sdk_version.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_c2pa_python_fn_func_sdk_version.restype = _UniffiRustBuffer
_UniffiLib.uniffi_c2pa_python_fn_func_sign_file.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_c2pa_python_fn_func_sign_file.restype = _UniffiRustBuffer
_UniffiLib.uniffi_c2pa_python_fn_func_version.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_c2pa_python_fn_func_version.restype = _UniffiRustBuffer
_UniffiLib.ffi_c2pa_python_rustbuffer_alloc.argtypes = (
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rustbuffer_alloc.restype = _UniffiRustBuffer
_UniffiLib.ffi_c2pa_python_rustbuffer_from_bytes.argtypes = (
    _UniffiForeignBytes,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rustbuffer_from_bytes.restype = _UniffiRustBuffer
_UniffiLib.ffi_c2pa_python_rustbuffer_free.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rustbuffer_free.restype = None
_UniffiLib.ffi_c2pa_python_rustbuffer_reserve.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rustbuffer_reserve.restype = _UniffiRustBuffer
_UniffiLib.ffi_c2pa_python_rust_future_continuation_callback_set.argtypes = (
    _UNIFFI_FUTURE_CONTINUATION_T,
)
_UniffiLib.ffi_c2pa_python_rust_future_continuation_callback_set.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_poll_u8.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_u8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_u8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_u8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_u8.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_u8.restype = ctypes.c_uint8
_UniffiLib.ffi_c2pa_python_rust_future_poll_i8.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_i8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_i8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_i8.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_i8.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_i8.restype = ctypes.c_int8
_UniffiLib.ffi_c2pa_python_rust_future_poll_u16.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_u16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_u16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_u16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_u16.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_u16.restype = ctypes.c_uint16
_UniffiLib.ffi_c2pa_python_rust_future_poll_i16.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_i16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_i16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_i16.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_i16.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_i16.restype = ctypes.c_int16
_UniffiLib.ffi_c2pa_python_rust_future_poll_u32.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_u32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_u32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_u32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_u32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_u32.restype = ctypes.c_uint32
_UniffiLib.ffi_c2pa_python_rust_future_poll_i32.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_i32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_i32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_i32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_i32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_i32.restype = ctypes.c_int32
_UniffiLib.ffi_c2pa_python_rust_future_poll_u64.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_u64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_u64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_u64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_u64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_u64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_u64.restype = ctypes.c_uint64
_UniffiLib.ffi_c2pa_python_rust_future_poll_i64.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_i64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_i64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_i64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_i64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_i64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_i64.restype = ctypes.c_int64
_UniffiLib.ffi_c2pa_python_rust_future_poll_f32.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_f32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_f32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_f32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_f32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_f32.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_f32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_f32.restype = ctypes.c_float
_UniffiLib.ffi_c2pa_python_rust_future_poll_f64.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_f64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_f64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_f64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_f64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_f64.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_f64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_f64.restype = ctypes.c_double
_UniffiLib.ffi_c2pa_python_rust_future_poll_pointer.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_pointer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_pointer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_pointer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_pointer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_pointer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_pointer.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_pointer.restype = ctypes.c_void_p
_UniffiLib.ffi_c2pa_python_rust_future_poll_rust_buffer.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_rust_buffer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_rust_buffer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_rust_buffer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_rust_buffer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_rust_buffer.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_rust_buffer.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_rust_buffer.restype = _UniffiRustBuffer
_UniffiLib.ffi_c2pa_python_rust_future_poll_void.argtypes = (
    ctypes.c_void_p,
    ctypes.c_size_t,
)
_UniffiLib.ffi_c2pa_python_rust_future_poll_void.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_cancel_void.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_cancel_void.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_free_void.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_c2pa_python_rust_future_free_void.restype = None
_UniffiLib.ffi_c2pa_python_rust_future_complete_void.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_c2pa_python_rust_future_complete_void.restype = None
_UniffiLib.uniffi_c2pa_python_checksum_func_read_file.argtypes = (
)
_UniffiLib.uniffi_c2pa_python_checksum_func_read_file.restype = ctypes.c_uint16
_UniffiLib.uniffi_c2pa_python_checksum_func_read_ingredient_file.argtypes = (
)
_UniffiLib.uniffi_c2pa_python_checksum_func_read_ingredient_file.restype = ctypes.c_uint16
_UniffiLib.uniffi_c2pa_python_checksum_func_sdk_version.argtypes = (
)
_UniffiLib.uniffi_c2pa_python_checksum_func_sdk_version.restype = ctypes.c_uint16
_UniffiLib.uniffi_c2pa_python_checksum_func_sign_file.argtypes = (
)
_UniffiLib.uniffi_c2pa_python_checksum_func_sign_file.restype = ctypes.c_uint16
_UniffiLib.uniffi_c2pa_python_checksum_func_version.argtypes = (
)
_UniffiLib.uniffi_c2pa_python_checksum_func_version.restype = ctypes.c_uint16
_UniffiLib.ffi_c2pa_python_uniffi_contract_version.argtypes = (
)
_UniffiLib.ffi_c2pa_python_uniffi_contract_version.restype = ctypes.c_uint32
_uniffi_check_contract_api_version(_UniffiLib)
_uniffi_check_api_checksums(_UniffiLib)

# Async support

# Public interface members begin here.


class _UniffiConverterUInt8(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u8"
    VALUE_MIN = 0
    VALUE_MAX = 2**8

    @staticmethod
    def read(buf):
        return buf.read_u8()

    @staticmethod
    def write_unchecked(value, buf):
        buf.write_u8(value)

class _UniffiConverterString:
    @staticmethod
    def check(value):
        if not isinstance(value, str):
            raise TypeError("argument must be str, not {}".format(type(value).__name__))
        return value

    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative string length")
        utf8_bytes = buf.read(size)
        return utf8_bytes.decode("utf-8")

    @staticmethod
    def write(value, buf):
        value = _UniffiConverterString.check(value)
        utf8_bytes = value.encode("utf-8")
        buf.write_i32(len(utf8_bytes))
        buf.write(utf8_bytes)

    @staticmethod
    def lift(buf):
        with buf.consume_with_stream() as stream:
            return stream.read(stream.remaining()).decode("utf-8")

    @staticmethod
    def lower(value):
        value = _UniffiConverterString.check(value)
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            builder.write(value.encode("utf-8"))
            return builder.finalize()


class SignerInfo:
    alg: "str";sign_cert: "typing.List[int]";private_key: "typing.List[int]";ta_url: "typing.Optional[str]";

    @typing.no_type_check
    def __init__(self, alg: "str", sign_cert: "typing.List[int]", private_key: "typing.List[int]", ta_url: "typing.Optional[str]"):
        self.alg = alg
        self.sign_cert = sign_cert
        self.private_key = private_key
        self.ta_url = ta_url

    def __str__(self):
        return "SignerInfo(alg={}, sign_cert={}, private_key={}, ta_url={})".format(self.alg, self.sign_cert, self.private_key, self.ta_url)

    def __eq__(self, other):
        if self.alg != other.alg:
            return False
        if self.sign_cert != other.sign_cert:
            return False
        if self.private_key != other.private_key:
            return False
        if self.ta_url != other.ta_url:
            return False
        return True

class _UniffiConverterTypeSignerInfo(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return SignerInfo(
            alg=_UniffiConverterString.read(buf),
            sign_cert=_UniffiConverterSequenceUInt8.read(buf),
            private_key=_UniffiConverterSequenceUInt8.read(buf),
            ta_url=_UniffiConverterOptionalString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.alg, buf)
        _UniffiConverterSequenceUInt8.write(value.sign_cert, buf)
        _UniffiConverterSequenceUInt8.write(value.private_key, buf)
        _UniffiConverterOptionalString.write(value.ta_url, buf)


# Error
# We want to define each variant as a nested class that's also a subclass,
# which is tricky in Python.  To accomplish this we're going to create each
# class separately, then manually add the child classes to the base class's
# __dict__.  All of this happens in dummy class to avoid polluting the module
# namespace.
class Error(Exception):
    pass

_UniffiTempError = Error

class Error:  # type: ignore
    class Assertion(_UniffiTempError):
        def __repr__(self):
            return "Error.Assertion({})".format(repr(str(self)))
    _UniffiTempError.Assertion = Assertion # type: ignore
    class AssertionNotFound(_UniffiTempError):
        def __repr__(self):
            return "Error.AssertionNotFound({})".format(repr(str(self)))
    _UniffiTempError.AssertionNotFound = AssertionNotFound # type: ignore
    class Decoding(_UniffiTempError):
        def __repr__(self):
            return "Error.Decoding({})".format(repr(str(self)))
    _UniffiTempError.Decoding = Decoding # type: ignore
    class Encoding(_UniffiTempError):
        def __repr__(self):
            return "Error.Encoding({})".format(repr(str(self)))
    _UniffiTempError.Encoding = Encoding # type: ignore
    class FileNotFound(_UniffiTempError):
        def __repr__(self):
            return "Error.FileNotFound({})".format(repr(str(self)))
    _UniffiTempError.FileNotFound = FileNotFound # type: ignore
    class Io(_UniffiTempError):
        def __repr__(self):
            return "Error.Io({})".format(repr(str(self)))
    _UniffiTempError.Io = Io # type: ignore
    class Json(_UniffiTempError):
        def __repr__(self):
            return "Error.Json({})".format(repr(str(self)))
    _UniffiTempError.Json = Json # type: ignore
    class Manifest(_UniffiTempError):
        def __repr__(self):
            return "Error.Manifest({})".format(repr(str(self)))
    _UniffiTempError.Manifest = Manifest # type: ignore
    class ManifestNotFound(_UniffiTempError):
        def __repr__(self):
            return "Error.ManifestNotFound({})".format(repr(str(self)))
    _UniffiTempError.ManifestNotFound = ManifestNotFound # type: ignore
    class NotSupported(_UniffiTempError):
        def __repr__(self):
            return "Error.NotSupported({})".format(repr(str(self)))
    _UniffiTempError.NotSupported = NotSupported # type: ignore
    class Other(_UniffiTempError):
        def __repr__(self):
            return "Error.Other({})".format(repr(str(self)))
    _UniffiTempError.Other = Other # type: ignore
    class NullParameter(_UniffiTempError):
        def __repr__(self):
            return "Error.NullParameter({})".format(repr(str(self)))
    _UniffiTempError.NullParameter = NullParameter # type: ignore
    class RemoteManifest(_UniffiTempError):
        def __repr__(self):
            return "Error.RemoteManifest({})".format(repr(str(self)))
    _UniffiTempError.RemoteManifest = RemoteManifest # type: ignore
    class ResourceNotFound(_UniffiTempError):
        def __repr__(self):
            return "Error.ResourceNotFound({})".format(repr(str(self)))
    _UniffiTempError.ResourceNotFound = ResourceNotFound # type: ignore
    class Signature(_UniffiTempError):
        def __repr__(self):
            return "Error.Signature({})".format(repr(str(self)))
    _UniffiTempError.Signature = Signature # type: ignore
    class Verify(_UniffiTempError):
        def __repr__(self):
            return "Error.Verify({})".format(repr(str(self)))
    _UniffiTempError.Verify = Verify # type: ignore

Error = _UniffiTempError # type: ignore
del _UniffiTempError


class _UniffiConverterTypeError(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return Error.Assertion(
                _UniffiConverterString.read(buf),
            )
        if variant == 2:
            return Error.AssertionNotFound(
                _UniffiConverterString.read(buf),
            )
        if variant == 3:
            return Error.Decoding(
                _UniffiConverterString.read(buf),
            )
        if variant == 4:
            return Error.Encoding(
                _UniffiConverterString.read(buf),
            )
        if variant == 5:
            return Error.FileNotFound(
                _UniffiConverterString.read(buf),
            )
        if variant == 6:
            return Error.Io(
                _UniffiConverterString.read(buf),
            )
        if variant == 7:
            return Error.Json(
                _UniffiConverterString.read(buf),
            )
        if variant == 8:
            return Error.Manifest(
                _UniffiConverterString.read(buf),
            )
        if variant == 9:
            return Error.ManifestNotFound(
                _UniffiConverterString.read(buf),
            )
        if variant == 10:
            return Error.NotSupported(
                _UniffiConverterString.read(buf),
            )
        if variant == 11:
            return Error.Other(
                _UniffiConverterString.read(buf),
            )
        if variant == 12:
            return Error.NullParameter(
                _UniffiConverterString.read(buf),
            )
        if variant == 13:
            return Error.RemoteManifest(
                _UniffiConverterString.read(buf),
            )
        if variant == 14:
            return Error.ResourceNotFound(
                _UniffiConverterString.read(buf),
            )
        if variant == 15:
            return Error.Signature(
                _UniffiConverterString.read(buf),
            )
        if variant == 16:
            return Error.Verify(
                _UniffiConverterString.read(buf),
            )
        raise InternalError("Raw enum value doesn't match any cases")

    @staticmethod
    def write(value, buf):
        if isinstance(value, Error.Assertion):
            buf.write_i32(1)
        if isinstance(value, Error.AssertionNotFound):
            buf.write_i32(2)
        if isinstance(value, Error.Decoding):
            buf.write_i32(3)
        if isinstance(value, Error.Encoding):
            buf.write_i32(4)
        if isinstance(value, Error.FileNotFound):
            buf.write_i32(5)
        if isinstance(value, Error.Io):
            buf.write_i32(6)
        if isinstance(value, Error.Json):
            buf.write_i32(7)
        if isinstance(value, Error.Manifest):
            buf.write_i32(8)
        if isinstance(value, Error.ManifestNotFound):
            buf.write_i32(9)
        if isinstance(value, Error.NotSupported):
            buf.write_i32(10)
        if isinstance(value, Error.Other):
            buf.write_i32(11)
        if isinstance(value, Error.NullParameter):
            buf.write_i32(12)
        if isinstance(value, Error.RemoteManifest):
            buf.write_i32(13)
        if isinstance(value, Error.ResourceNotFound):
            buf.write_i32(14)
        if isinstance(value, Error.Signature):
            buf.write_i32(15)
        if isinstance(value, Error.Verify):
            buf.write_i32(16)



class _UniffiConverterOptionalString(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterString.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterString.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterSequenceUInt8(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterUInt8.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterUInt8.read(buf) for i in range(count)
        ]

def read_file(path: "str",data_dir: "typing.Optional[str]") -> "str":
    
    
    return _UniffiConverterString.lift(_rust_call_with_error(_UniffiConverterTypeError,_UniffiLib.uniffi_c2pa_python_fn_func_read_file,
        _UniffiConverterString.lower(path),
        _UniffiConverterOptionalString.lower(data_dir)))


def read_ingredient_file(path: "str",data_dir: "str") -> "str":
    
    
    return _UniffiConverterString.lift(_rust_call_with_error(_UniffiConverterTypeError,_UniffiLib.uniffi_c2pa_python_fn_func_read_ingredient_file,
        _UniffiConverterString.lower(path),
        _UniffiConverterString.lower(data_dir)))


def sdk_version() -> "str":
    return _UniffiConverterString.lift(_rust_call(_UniffiLib.uniffi_c2pa_python_fn_func_sdk_version,))


def sign_file(source: "str",dest: "str",manifest: "str",signer_info: "SignerInfo",data_dir: "typing.Optional[str]") -> "typing.List[int]":
    
    
    
    
    
    return _UniffiConverterSequenceUInt8.lift(_rust_call_with_error(_UniffiConverterTypeError,_UniffiLib.uniffi_c2pa_python_fn_func_sign_file,
        _UniffiConverterString.lower(source),
        _UniffiConverterString.lower(dest),
        _UniffiConverterString.lower(manifest),
        _UniffiConverterTypeSignerInfo.lower(signer_info),
        _UniffiConverterOptionalString.lower(data_dir)))


def version() -> "str":
    return _UniffiConverterString.lift(_rust_call(_UniffiLib.uniffi_c2pa_python_fn_func_version,))


__all__ = [
    "InternalError",
    "Error",
    "SignerInfo",
    "read_file",
    "read_ingredient_file",
    "sdk_version",
    "sign_file",
    "version",
]

